<?php

namespace Picea\ControlStructure;

class ForToken implements ControlStructure {

    public array $token = [ "for", "endfor" ];

    public function parse(/*\Picae\Compiler\Context*/ &$context, ?string $arguments, string $token) {
        switch($token) {
            case "for":
                $uid = "$".uniqid("for_");

                $context->iterationStack[] = [
                    'or' => false,
                    'uid' => $uid,
                    'token' => 'endfor',
                ];

                return "<?php for ($arguments): {$uid} = 1; ?>";
                
            case "endfor":
                if ( end($context->iterationStack)['or'] === false ) {
                    $output = "<?php endfor; ?>";
                }
                else {
                    $output = "<?php endif; ?>";
                }

                array_pop($context->iterationStack);

                return $output;
        }
    }
}
